#include <msp430.h> 

/**
 RU: Пример для изучения работы микроконтроллера серии CC430 на отладочной плате TiTAN.
    если определен UARTFET, тогда
     TX - P2.7 (установить перемычку TXD)
     RX - P2.6 (установить перемычку RXD)
    иначе 
     TX - P1.6 (используйте контакт TX->1)
     RX - P1.5 (используйте контакт RX<-0)
 ENG: An example for studying the operation of a СС430 series microcontroller on a TiTAN debug card.
    if defined UARTFET
     TX - P2.7 (close TXD jumper)
     RX - P2.6 (close RXD jumper)
    else
     TX - P1.6 (use pin TX->1)
     RX - P1.5 (use pin RX<-0)
      
 author: Valery Beloglazov
 */
 
#include "main.h"
#include "system.h"
#include "uart.h"


int main(void)
{
	WDTCTL = WDTPW | WDTHOLD;	                        // stop watchdog timer
    SetSystemClock20MHz();                              // set system clock
    UART_init();                                        //initialization UART
    __enable_interrupt();                               // global interrupt enabled

	while(1) {
	}
	return 0;
}

/**************************************************
 * 
 * UART interrupt handler
 * 
 *************************************************/
#pragma vector=USCI_A0_VECTOR
__interrupt void USCI_A0_ISR(void)
{
  switch(__even_in_range(UCA0IV,4))
  {
  case 0:break;                             // Vector 0 - no interrupt
  case 2:                                   // Vector 2 - RXIFG
    while (!(UCA0IFG&UCTXIFG));             // USCI_A0 TX buffer 
    UCA0TXBUF = UCA0RXBUF;                  // TX -> RXed character
    break;
  case 4:break;                             // Vector 4 - TXIFG
  default: break;
  }
}
