#ifndef SYSTEM_H_
#define SYSTEM_H_

void SetSystemClock20MHz(void) {
    _BIS_SR(SCG0);                                      // Disable the FLL control loop
    UCSCTL0 = 0x0000;                                   // Set lowest possible DCOx, MODx
    UCSCTL1 = DCORSEL_7;                                // Select suitable range
    UCSCTL2 = FLLD_2 | 610;                             // Set DCO Multiplier 20Mhz ~~ 32768*610=19988480Hz
    _BIC_SR(SCG0);                                      // Enable the FLL control loop*/
}


//function for milliseconds delay 
void delay_ms(unsigned int delay) {
	while (delay--) {
		__delay_cycles(19988);                           //because system clock
	}
}


#endif /* SYSTEM_H_ */
