#include <msp430.h>
#include "uart.h"

#define UARTFET     YES


void UART_init() {

#ifdef UARTFET
    PMAPPWD = 0x02D52;                      // Get write-access to port mapping regs  
    P2MAP7 = PM_UCA0RXD;                    // Map UCA0RXD output to P2.7           BUG!!! 
    P2MAP6 = PM_UCA0TXD;                    // Map UCA0TXD output to P2.6           BUG!!!
    PMAPPWD = 0;                            // Lock port mapping registers 
    
    P2DIR |= BIT6;                          // Set P2.6 as TX output                BUG!!!
    P2SEL |= BIT6 + BIT7;                   // Select P2.6 & P2.7 to UART function

#else
	  PMAPPWD = 0x02D52;                    // Get write-access to port mapping regs
	  P1MAP5 = PM_UCA0RXD;                  // Map UCA0RXD output to P1.5
	  P1MAP6 = PM_UCA0TXD;                  // Map UCA0TXD output to P1.6
	  PMAPPWD = 0;                          // Lock port mapping registers 

	  P1DIR |= BIT6;                        // P1.6 at TX output
	  P1SEL |= BIT5 + BIT6;                 // Select P1.5 & P1.6 to UART function
#endif

	//setup UART
	UCA0CTL1 |= UCSWRST;                    // UART stop
	UCA0CTL1 |= UCSSEL_2;                   // SMCLK clock (20MHz) and enable RX inte
	UCA0BR0 = 0xAD;                         // 20 MHz 115200 (read datasheet)
	UCA0BR1 = 0x00;                         // 20 MHz 115200
	UCA0MCTL |= UCBRS_5 + UCBRF_0;          // Modulation BRS=5, BRF=0
	UCA0CTL1 &= ~UCSWRST;                   // UART reset
	UCA0IE |= UCRXIE;                       // enable RX interrupt
}
